//         .
//     .    (   ) 
//           (   ). 
//     ,          
//     .       
//  .        ,
//    .
#include <Trade\Trade.mqh>
#include <Trade\OrderInfo.mqh>
#include <Trade\PositionInfo.mqh>
class CPiramid
  {
private:
int  Correl;//   
bool Delgrid;//    
double   point1;
double   point2;// Point()   
int  digit1 ;//
int  digit2;// Digit()    
int  PointGrid1;//     30-100  10
int  PointGrid2;//     30-100  10
bool firstate1;//       
//bool firstate2;//     
bool  wirk;//      
ulong Mgmy1 ;//    
//ulong Mgmy2 ;//   
string   Instrum1 ;//   
string   Instrum2 ;//  
double   firlot;//      
MqlTick pricemy1;//     
MqlTick pricemy2;//      
MqlDateTime Time;// 
int StartTimecl;//     
int EndTimecl;//   
//MqlDateTime EndTraning;//   
CTrade   trade;// 
COrderInfo orderinfo;//  
CPositionInfo  posinfo;//  
//============================================================================================
public:
        CPiramid();
        ~CPiramid();
   void  SetMg(ulong MgSet1) {Mgmy1=MgSet1;}// 
   void  SetGrid(int Step1){PointGrid1=Step1;}//   
   void  SetLot(double Lot){firlot=Lot ;}//   
   void  SetInstrum(string Name1,string Name2);//     
   void  OnTickmy();//    
   void  SetWirk(bool wr){wirk=wr;}//       
   double GetProfit() ;//      
   void  ClosePos();//      
   void  SetCorrelation(int Cor){Correl=Cor ;}//    
   void  SetTime(int Sttran,int Endtran) {StartTimecl=Sttran; EndTimecl=Endtran ;}//   
   //    
private:
   void SetOrder(string Nam,ENUM_ORDER_TYPE tipeorder,int grid,double point) ;//    
   int  GetTipePos(string  Nam);//    1  -1  0   
   void DelOrder(string Nam,ENUM_ORDER_TYPE tipeorder);//  
   void CorrectOrder(string Nam,ENUM_ORDER_TYPE tipeorder,int grid,double point);//     
                                                           // PointGrid   
  };
//==================================================================================
void     CPiramid::SetInstrum(string Name1,string Name2)
   {
      Instrum1=Name1;
      Instrum2=Name2 ;
      point1=SymbolInfoDouble(Name1,SYMBOL_POINT);
      point2=SymbolInfoDouble(Name2,SYMBOL_POINT) ;
      digit1=(int)SymbolInfoInteger(Name1,SYMBOL_DIGITS);  
      digit2=(int)SymbolInfoInteger(Name2,SYMBOL_DIGITS) ;
      PointGrid2=PointGrid1 ;
      if(digit1 == 3 || digit1 == 5 ) PointGrid1*=10 ;
      if(digit2 == 3 || digit2 == 5 ) PointGrid2*=10 ;   
   }
//===================================================================================
double   CPiramid::GetProfit()
   {//       
      double   prof=0;
      if(GetTipePos(Instrum1) !=0) prof+=posinfo.Profit() ;
      if(GetTipePos(Instrum2) !=0) prof+=posinfo.Profit() ;
      return(prof) ;
   }
//==================================================================================
void  CPiramid::ClosePos()
   {//         
      trade.PositionClose(Instrum1,-1) ;
      trade.PositionClose(Instrum2,-1) ;
      DelOrder(Instrum1,ORDER_TYPE_BUY_STOP);//   
      DelOrder(Instrum1,ORDER_TYPE_SELL_STOP);//   
      DelOrder(Instrum2,ORDER_TYPE_BUY_STOP);//   
      DelOrder(Instrum2,ORDER_TYPE_SELL_STOP);//   
      firstate1=true ;//      
      //firstate2=true ;
   }
//==================================================================================
void CPiramid::OnTickmy()
   {//  OnTick   
      if(!wirk) return ;//        
      TimeCurrent(Time) ;
      bool aaa=(StartTimecl > Time.min+Time.hour*60) || (EndTimecl < Time.min+Time.hour*60)
            || (StartTimecl > EndTimecl) ;
      if(GetTipePos(Instrum1)== 0 && firstate1 && GetTipePos(Instrum2)==0 && !aaa)
         {//          
            DelOrder(Instrum1,ORDER_TYPE_BUY_STOP);//   
            DelOrder(Instrum1,ORDER_TYPE_SELL_STOP);//   
            DelOrder(Instrum2,ORDER_TYPE_BUY_STOP);//   
            DelOrder(Instrum2,ORDER_TYPE_SELL_STOP);//   
            SetOrder(Instrum1,ORDER_TYPE_BUY_STOP,PointGrid1,point1);//      
            SetOrder(Instrum1,ORDER_TYPE_SELL_STOP,PointGrid1,point1);//      
            firstate1=false ;//  
            //Delgrid=false ;
         }

       if(GetTipePos(Instrum1) ==1 && Correl == 1)// && !Delgrid)
         {//             
            DelOrder(Instrum1,ORDER_TYPE_SELL_STOP);
            CorrectOrder(Instrum1,ORDER_TYPE_BUY_STOP,PointGrid1,point1) ;//  
            CorrectOrder(Instrum2,ORDER_TYPE_SELL_STOP,PointGrid2,point2); //  
            
         }
       if(GetTipePos(Instrum1) == -1 && Correl == 1)// && !Delgrid)
         {//             
            DelOrder(Instrum1,ORDER_TYPE_BUY_STOP);
            CorrectOrder(Instrum1,ORDER_TYPE_SELL_STOP,PointGrid1,point1) ;// 
            CorrectOrder(Instrum2,ORDER_TYPE_BUY_STOP,PointGrid2,point2);
            
         }
//------------------------------------------------------------------------------------------------------------------
            if(GetTipePos(Instrum1) ==1 && Correl == -1 && !Delgrid)
               {//             
                  DelOrder(Instrum1,ORDER_TYPE_SELL_STOP);
                  CorrectOrder(Instrum1,ORDER_TYPE_BUY_STOP,PointGrid1,point1) ;//  
                  CorrectOrder(Instrum2,ORDER_TYPE_SELL_STOP,PointGrid2,point2); //  
               }
            if(GetTipePos(Instrum1) == -1 && Correl == -1 && !Delgrid)
               {//             
                  DelOrder(Instrum1,ORDER_TYPE_BUY_STOP);
                  CorrectOrder(Instrum1,ORDER_TYPE_SELL_STOP,PointGrid1,point1) ;// 
                  CorrectOrder(Instrum2,ORDER_TYPE_BUY_STOP,PointGrid2,point2);
               }   
   }
//==================================================================================
void  CPiramid::DelOrder(string Nam,ENUM_ORDER_TYPE tipeorder)
   {//  
   int i,total=OrdersTotal();
   ulong ticket;
   for(i=total-1; i>=0;i--)
     {
      if((ticket=OrderGetTicket(i))>0)
         if(orderinfo.Symbol() == Nam && orderinfo.OrderType()== tipeorder)
           {
            trade.OrderDelete(ticket);
           }
     }
      return;
   }
//===================================================
void  CPiramid::CorrectOrder(string Nam,ENUM_ORDER_TYPE tipeorder,int grid,double point)
   {
   int i,total=OrdersTotal(),cnt=0;
   ulong ticket;
   SymbolInfoTick(Nam,pricemy1);//  
   bool  correct=true ;
   for(i=total-1; i>=0;i--)
     {
      if((ticket=OrderGetTicket(i))>0 && orderinfo.Symbol() == Nam && orderinfo.OrderType()== tipeorder)
       {
        cnt++ ; //    
        if(tipeorder == ORDER_TYPE_BUY_STOP && (orderinfo.PriceOpen()-pricemy1.ask < (grid+50)*point))
         {//
            correct=false ;
         }
        if(tipeorder == ORDER_TYPE_SELL_STOP && (pricemy1.ask-orderinfo.PriceOpen() < (grid+50)*point))
         {//
             correct=false ;
         }
       }
      
     }
     if(cnt <2 || correct) 
      {//             
       DelOrder(Nam,tipeorder) ;
       SetOrder(Nam,tipeorder,grid,point) ;
       return ;
      }
      return;
   }
//==================================================================================
void  CPiramid::SetOrder(string Nam,ENUM_ORDER_TYPE tipeorder,int grid,double point)
   {//          PointGrid1
      SymbolInfoTick(Nam,pricemy1);//   
      int i ;
      double oppossel1,opposbuy1;//   
      for(i=1 ;i<=10 ;i++)
         {
            trade.SetExpertMagicNumber(Mgmy1);// 
            if(tipeorder == ORDER_TYPE_SELL_STOP)
            {//
               oppossel1=NormalizeDouble(pricemy1.bid-grid*point*i,digit1) ;//   sell 
               trade.SellStop(firlot,oppossel1,Nam,0,0,0,0,NULL) ;
            }
            if(tipeorder == ORDER_TYPE_BUY_STOP)
            {//
               opposbuy1=NormalizeDouble(pricemy1.ask+grid*point*i,digit1) ;//    
               trade.BuyStop(firlot,opposbuy1,Nam,0,0,0,0,NULL) ;
            }
         }
      return ;
   }
//====================================================================================
int CPiramid::GetTipePos(string  Nam)
   {//        1   , -1   , 0  
      if(posinfo.Select(Nam) == true)
         {
            if(posinfo.PositionType() == POSITION_TYPE_BUY) return(1) ;
            if(posinfo.PositionType() == POSITION_TYPE_SELL) return(-1) ;
         }
      return(0);
   }
//=======================================================================================

//=========================================================================================
CPiramid::CPiramid()
  {
   PointGrid1=30 ;
   //PointGrid2=30 ;
   firstate1=true ;
   //firstate2=true ;
   Mgmy1=MathRand()+1 ;
   //Mgmy2=MathRand()+1 ;
   firlot=0.1 ;  
   wirk=false ;
   Correl=1 ;
   StartTimecl=0 ;
   EndTimecl=1440 ;
  }
//======================================================================
CPiramid::~CPiramid()
  {
  }
//+------------------------------------------------------------------+
